## meshlab 2020.03%2Bdfsg1

=== src/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

cmake_minimum_required(VERSION 3.9)
project(MeshLab)

# Prefer GLVND
if(POLICY CMP0072)
    cmake_policy(SET CMP0072 NEW)
endif()

### vcglib
if(NOT VCGDIR)
    get_filename_component(VCGDIR "${CMAKE_CURRENT_SOURCE_DIR}/../vcglib" ABSOLUTE)
    if(NOT EXISTS ${VCGDIR})
        set(VCGDIR NOTFOUND)
    endif()
endif()
set(VCGDIR
    "${VCGDIR}"
    CACHE PATH "The location of the vcglib source tree - defaults to sibling of meshlab directory.")

if(NOT VCGDIR)
    message(
        FATAL_ERROR
            "vcglib is required to build MeshLab. Please get the source and set VCGDIR to its location: default location is as a sibling to the meshlab directory above this directory."
    )
endif()

### Build options

option(BUILD_MINI "Build only a minimal set of plugins" OFF)
option(BUILD_STRICT "Strictly enforce resolution of all symbols" ON)
set(BUILD_ADDITIONAL_PLUGINS
    ${BUILD_ADDITIONAL_PLUGINS}
    CACHE
        STRING
        "A list of other plugin subdirectories to recurse into (e.g. select experimental or unsupported plugins) - relative to meshlab/src"
)

option(ALLOW_BUNDLED_EIGEN "Allow use of bundled Eigen source" ON)
option(ALLOW_BUNDLED_GLEW "Allow use of bundled GLEW source" ON)
option(ALLOW_BUNDLED_NEWUOA "Allow use of bundled newuoa source" ON)
option(ALLOW_BUNDLED_LEVMAR "Allow use of bundled levmar source" ON)
option(ALLOW_BUNDLED_LIB3DS "Allow use of bundled lib3ds source" ON)
# option(ALLOW_BUNDLED_MPIR "Allow use of bundled MPIR binaries" ON) # TODO
option(ALLOW_BUNDLED_MUPARSER "Allow use of bundled muparser source" ON)
option(ALLOW_BUNDLED_OPENCTM "Allow use of bundled OpenCTM source" ON)
option(ALLOW_BUNDLED_SSYNTH "Allow use of bundled structure-synth source" ON)
option(ALLOW_BUNDLED_QHULL "Allow use of bundled Qhull source" ON)

option(ALLOW_SYSTEM_EIGEN "Allow use of system-provided Eigen" ON)
option(ALLOW_SYSTEM_GLEW "Allow use of system-provided GLEW" ON)
option(ALLOW_SYSTEM_LIB3DS "Allow use of system-provided lib3ds" ON)
option(ALLOW_SYSTEM_GMP "Allow use of system-provided GMP" ON)
option(ALLOW_SYSTEM_MUPARSER "Allow use of system-provided muparser" ON)
option(ALLOW_SYSTEM_OPENCTM "Allow use of system-provided OpenCTM" ON)
option(ALLOW_SYSTEM_QHULL "Allow use of system-provided QHull" ON)

### Dependencies
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
message(STATUS "Searching for required components")
find_package(OpenGL REQUIRED)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
find_package(
    Qt5
    COMPONENTS OpenGL Xml XmlPatterns Script
    REQUIRED)

message(STATUS "Searching for required components with bundled fallback")
find_package(GLEW)
find_package(Eigen3)

message(STATUS "Searching for optional components")
find_package(Lib3ds)
find_package(GMP)
find_package(muparser)
find_package(OpenCTM)
# TODO dynamic qhull that isn't qhull_r is deprecated: port to qhull_r
find_package(Qhull COMPONENTS qhull)
find_package(OpenMP)

if(WIN32)
    option(INSTALL_TO_UNIX_LAYOUT
           "Should the files be installed to a unix layout? If false, they will be installed more like the build tree."
           OFF)

    get_target_property(Qt5_qmake_EXECUTABLE Qt5::qmake IMPORTED_LOCATION)
    get_filename_component(Qt5_BIN_DIR "${Qt5_qmake_EXECUTABLE}" DIRECTORY)
    find_program(
        Qt5_windeployqt_EXECUTABLE
        NAMES windeployqt
        HINTS ${Qt5_BIN_DIR})
    if(Qt5_windeployqt_EXECUTABLE)
        option(BUILD_WITH_WINDEPLOYQT_POST_BUILD
               "Should we run windeployqt after the build to copy the qt parts to the build tree?" ON)
    endif()
else()
    set(INSTALL_TO_UNIX_LAYOUT ON)
endif()

option(INSTALL_SAMPLE_MESHES
       "Should the sample meshes in src/distrib/samples be installed? It will increase the installed size by 14 MiB."
       OFF)
option(
    INSTALL_SAMPLE_RANGEMAPS
    "Should the sample rangemaps in src/distrib/samples/rangemaps be installed? It will increase the installed size by 67 MiB."
    OFF)

### Settings needed for both "external" and internal code
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

### Bundled dependencies in the "external" directory
set(EXTERNAL_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external)
include("${CMAKE_CURRENT_SOURCE_DIR}/external.cmake")

### Install directories and build/staging directories
include(GNUInstallDirs)
if(INSTALL_TO_UNIX_LAYOUT)
    set(MESHLAB_BIN_INSTALL_DIR ${CMAKE_INSTALL_BINDIR})
    set(MESHLAB_LIB_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/meshlab)
    set(MESHLAB_PLUGIN_INSTALL_DIR ${MESHLAB_LIB_INSTALL_DIR}/plugins)
    set(MESHLAB_SHADER_INSTALL_DIR ${CMAKE_INSTALL_DATAROOTDIR}/meshlab/shaders)
    set(MESHLAB_SAMPLE_INSTALL_DIR ${CMAKE_INSTALL_DATAROOTDIR}/meshlab)
else()
    set(MESHLAB_BIN_INSTALL_DIR .)
    set(MESHLAB_LIB_INSTALL_DIR .)
    set(MESHLAB_PLUGIN_INSTALL_DIR plugins)
    set(MESHLAB_SHADER_INSTALL_DIR shaders)
    set(MESHLAB_SAMPLE_INSTALL_DIR .)
endif()

set(MESHLAB_BUILD_DISTRIB_DIR ${CMAKE_CURRENT_BINARY_DIR}/distrib)
set(MESHLAB_PLUGIN_OUTPUT_DIR ${MESHLAB_BUILD_DISTRIB_DIR}/plugins)
set(MESHLAB_SHADER_OUTPUT_DIR ${MESHLAB_BUILD_DISTRIB_DIR}/shaders)
set(MESHLAB_SAMPLE_OUTPUT_DIR ${MESHLAB_BUILD_DISTRIB_DIR}/sample)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${MESHLAB_BUILD_DISTRIB_DIR})

### Common build settings for internal code
include_directories(${VCGDIR} ${CMAKE_CURRENT_SOURCE_DIR})

# This gets set to system or local, as appropriate, by external.cmake
include_directories(${EIGEN_INCLUDE_DIRS})

add_definitions(-DMESHLAB_SCALAR=float)

if(BUILD_STRICT AND NOT MSVC)
    # Make sure that our shared libraries were appropriately linked
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--no-undefined")
endif()

if(WIN32)
    add_definitions(-DNOMINMAX)
    if(MSVC)
        add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
    endif()
endif()


### Enter subdirectories
add_subdirectory(common)

set(CMAKE_INSTALL_RPATH $ORIGIN/../${MESHLAB_LIB_INSTALL_DIR};$ORIGIN/../${CMAKE_INSTALL_LIBDIR})
add_subdirectory(meshlab)
add_subdirectory(meshlabserver)
set(CMAKE_INSTALL_RPATH)

### Plugin subdirectories
if(BUILD_MINI)
    # mini
    set(POSSIBLE_PLUGINS
        meshlabplugins/io_base
        meshlabplugins/filter_meshing
        meshlabplugins/decorate_base
        meshlabplugins/filter_measure)
else()
    # full

    set(POSSIBLE_PLUGINS
        # IO plugins
        meshlabplugins/io_3ds
        meshlabplugins/io_base
        meshlabplugins/io_bre
        meshlabplugins/io_collada
        meshlabplugins/io_ctm
        meshlabplugins/io_expe
        meshlabplugins/io_json
        meshlabplugins/io_pdb
        meshlabplugins/io_tri
        meshlabplugins/io_txt
        meshlabplugins/io_u3d
        meshlabplugins/io_x3d


        # Filter plugins
        # meshlabplugins/filter_aging # not in qmake file?
        # meshlabplugins/filter_bnpts # not in qmake file?
        meshlabplugins/filter_ao
        meshlabplugins/filter_camera
        meshlabplugins/filter_clean
        meshlabplugins/filter_color_projection
        meshlabplugins/filter_colorproc
        meshlabplugins/filter_create
        meshlabplugins/filter_csg
        meshlabplugins/filter_dirt
        meshlabplugins/filter_fractal
        meshlabplugins/filter_func
        meshlabplugins/filter_img_patch_param
        meshlabplugins/filter_isoparametrization
        meshlabplugins/filter_layer
        meshlabplugins/filter_measure
        meshlabplugins/filter_meshing
        meshlabplugins/filter_mls
        meshlabplugins/filter_mutualglobal
        meshlabplugins/filter_mutualinfoxml # TODO rename dir - actually named filter_mutualinfo
        meshlabplugins/filter_plymc
        meshlabplugins/filter_qhull
        meshlabplugins/filter_quality
        meshlabplugins/filter_sampling
        meshlabplugins/filter_screened_poisson
        meshlabplugins/filter_sdfgpu
        meshlabplugins/filter_select
        meshlabplugins/filter_sketchfab
        meshlabplugins/filter_ssynth
        meshlabplugins/filter_texture
        meshlabplugins/filter_trioptimize
        meshlabplugins/filter_unsharp
        meshlabplugins/filter_voronoi

        # Rendering and Decoration Plugins
        meshlabplugins/render_gdp
        meshlabplugins/render_radiance_scaling
        meshlabplugins/decorate_base
        meshlabplugins/decorate_background
        meshlabplugins/decorate_raster_proj
        meshlabplugins/decorate_shadow

        # Edit Plugins
        meshlabplugins/edit_align
        # meshlabplugins/edit_hole # not in qmake file?
        meshlabplugins/edit_manipulators
        meshlabplugins/edit_measure
        meshlabplugins/edit_mutualcorrs
        meshlabplugins/edit_paint
        # meshlabplugins/edit_pickpoints # not in qmake file?
        meshlabplugins/edit_point
        meshlabplugins/edit_referencing
        meshlabplugins/edit_quality
        meshlabplugins/edit_select
        # meshlabplugins/edit_slice # not in qmake file?
        # meshlabplugins/edit_texture # not in qmake file?

        # Sample Plugins
        sampleplugins/sampleedit
        sampleplugins/samplefilter
        sampleplugins/samplefilterdyn
        sampleplugins/filter_createiso
        sampleplugins/filter_geodesic
        sampleplugins/sample_filtergpu)
endif()

function(meshlab_install_plugin_xml FN OUTVAR)
    get_filename_component(NAME_ONLY ${FN} NAME)
    set(OUTFN ${MESHLAB_PLUGIN_OUTPUT_DIR}/${NAME_ONLY})
    add_custom_command(
        OUTPUT ${OUTFN}
        COMMAND ${CMAKE_COMMAND} -E make_directory "${MESHLAB_PLUGIN_OUTPUT_DIR}"
        COMMAND ${CMAKE_COMMAND} -E copy_if_different "${FN}" "${OUTFN}"
        COMMENT "Copying ${NAME_ONLY} to plugin build directory"
        VERBATIM)
    install(
        FILES ${FN}
        DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
        COMPONENT Plugins)
    set(${OUTVAR}
        ${OUTFN}
        PARENT_SCOPE)
endfunction()

message(STATUS "\nConfiguring plugins")
foreach(PLUGIN ${POSSIBLE_PLUGINS})
    if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${PLUGIN}/CMakeLists.txt)
        message(STATUS "- ${PLUGIN}")
        add_subdirectory(${PLUGIN})
    else()
        message(STATUS "  - ${PLUGIN} - Skipping, plugin or build system not found.")
    endif()
endforeach()
if(BUILD_ADDITIONAL_PLUGINS)
    message(STATUS "\nConfiguring plugins specified in BUILD_ADDITIONAL_PLUGINS")
endif()
foreach(PLUGIN ${BUILD_ADDITIONAL_PLUGINS})
    get_filename_component(PLUGIN_DIR ${PLUGIN} ABSOLUTE BASE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
    if(EXISTS ${PLUGIN_DIR}/CMakeLists.txt)
        message(STATUS "- ${PLUGIN}")
        add_subdirectory(${PLUGIN_DIR})
    else()
        message(FATAL_ERROR "${PLUGIN} - Additional plugin specified in BUILD_ADDITIONAL_PLUGINS but not found.")
    endif()
endforeach()

### Copy/install other files

# This variable keeps track of the output filenames that need to be copied at build time
set(COPIED_FILES)

# shaders
# TODO subdirs?
file(
    GLOB SHADERS
    LIST_DIRECTORIES false
    "${CMAKE_CURRENT_SOURCE_DIR}/../distrib/shaders/*.vert" "${CMAKE_CURRENT_SOURCE_DIR}/../distrib/shaders/*.frag"
    "${CMAKE_CURRENT_SOURCE_DIR}/../distrib/shaders/*.gdp")
foreach(FN ${SHADERS})
    get_filename_component(NAME_ONLY ${FN} NAME)
    set(OUTFN ${MESHLAB_SHADER_OUTPUT_DIR}/${NAME_ONLY})
    add_custom_command(
        OUTPUT ${OUTFN}
        COMMAND ${CMAKE_COMMAND} -E make_directory "${MESHLAB_SHADER_OUTPUT_DIR}"
        COMMAND ${CMAKE_COMMAND} -E copy_if_different "${FN}" "${OUTFN}"
        COMMENT "Copying ${NAME_ONLY} to shader build directory"
        VERBATIM)
    install(
        FILES ${FN}
        DESTINATION ${MESHLAB_SHADER_INSTALL_DIR}
        COMPONENT Shaders)
    list(APPEND COPIED_FILES "${OUTFN}")
endforeach()

# Custom target - to trigger the execution of the custom commands above.

=== src/meshlabplugins/decorate_shadow/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES
    decorate_shadow.cpp
    shadow_mapping.cpp
    ssao.cpp
    variance_shadow_mapping.cpp
    variance_shadow_mapping_blur.cpp
    ${VCGDIR}/wrap/gui/trackball.cpp
    ${VCGDIR}/wrap/gui/trackmode.cpp)

set(HEADERS
    decorate_shader.h
    decorate_shadow.h
    shadow_mapping.h
    ssao.h
    variance_shadow_mapping.h
    variance_shadow_mapping_blur.h
    ${VCGDIR}/wrap/gui/trackball.h)

set(RESOURCES noise.qrc)

add_library(decorate_shadow MODULE ${SOURCES} ${HEADERS} ${RESOURCES})

target_include_directories(decorate_shadow PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(decorate_shadow PUBLIC common)

target_link_libraries(decorate_shadow PRIVATE OpenGL::GLU)

set_property(TARGET decorate_shadow PROPERTY FOLDER Plugins)

set_property(TARGET decorate_shadow PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                             ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET decorate_shadow PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                             ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(TARGETS decorate_shadow DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
                COMPONENT Plugins)

=== src/meshlabplugins/edit_mutualcorrs/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

# Only build if we have newuoa and levmar
if(TARGET external-newuoa AND TARGET external-levmar)

    set(SOURCES
        alignset.cpp
        edit_mutualcorrs.cpp
        edit_mutualcorrsDialog.cpp
        edit_mutualcorrs_factory.cpp
        levmarmethods.cpp
        mutual.cpp
        parameters.cpp
        solver.cpp)

    set(HEADERS
        alignset.h
        edit_mutualcorrs.h
        edit_mutualcorrsDialog.h
        edit_mutualcorrs_factory.h
        levmarmethods.h
        mutual.h
        parameters.h
        shutils.h
        solver.h)

    set(RESOURCES edit_mutualcorrs.qrc)

    set(UI edit_mutualcorrsDialog.ui)

    add_library(edit_mutualcorrs MODULE ${SOURCES} ${HEADERS} ${RESOURCES}
                                        ${UI})

    target_include_directories(edit_mutualcorrs
                               PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
    target_link_libraries(edit_mutualcorrs PUBLIC common)

    target_link_libraries(edit_mutualcorrs PRIVATE external-newuoa
                                                   external-levmar)

    target_link_libraries(edit_mutualcorrs PRIVATE OpenGL::GLU)

    set_property(TARGET edit_mutualcorrs PROPERTY FOLDER Plugins)

    set_property(TARGET edit_mutualcorrs PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                                  ${MESHLAB_PLUGIN_OUTPUT_DIR})

    set_property(TARGET edit_mutualcorrs PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                                  ${MESHLAB_PLUGIN_OUTPUT_DIR})

    install(TARGETS edit_mutualcorrs DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
                    COMPONENT Plugins)

else()
    message(
        STATUS
            "Skipping edit_mutualcorrs - missing either newuoa or levmar in external directory."
    )
endif()

=== src/meshlabplugins/edit_paint/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES edit_paint.cpp edit_paint_factory.cpp paintbox.cpp)

set(HEADERS cloneview.h colorframe.h edit_paint.h edit_paint_factory.h
            paintbox.h)

set(RESOURCES edit_paint.qrc)

set(UI paintbox.ui)

add_library(edit_paint MODULE ${SOURCES} ${HEADERS} ${RESOURCES} ${UI})

target_include_directories(edit_paint PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(edit_paint PUBLIC common)

target_link_libraries(edit_paint PRIVATE OpenGL::GLU)

set_property(TARGET edit_paint PROPERTY FOLDER Plugins)

set_property(TARGET edit_paint PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                        ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET edit_paint PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                        ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(TARGETS edit_paint DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR} COMPONENT
                Plugins)

=== src/meshlabplugins/filter_clean/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES cleanfilter.cpp)

set(HEADERS cleanfilter.h)

add_library(filter_clean MODULE ${SOURCES} ${HEADERS})

target_include_directories(filter_clean PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(filter_clean PUBLIC common)

set_property(TARGET filter_clean PROPERTY FOLDER Plugins)

set_property(TARGET filter_clean PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                          ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET filter_clean PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                          ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(TARGETS filter_clean DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
                COMPONENT Plugins)

=== src/meshlabplugins/filter_fractal/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES filter_fractal.cpp)

set(HEADERS craters_utils.h filter_fractal.h filter_functors.h fractal_utils.h)

set(RESOURCES ff_res.qrc)

add_library(filter_fractal MODULE ${SOURCES} ${HEADERS} ${RESOURCES})

target_include_directories(filter_fractal PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(filter_fractal PUBLIC common)

set_property(TARGET filter_fractal PROPERTY FOLDER Plugins)

set_property(TARGET filter_fractal PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                            ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET filter_fractal PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                            ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(TARGETS filter_fractal DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
                COMPONENT Plugins)

=== src/meshlabplugins/filter_measure/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES filter_measure.cpp)

set(HEADERS filter_measure.h)

set(XML filter_measure.xml)
meshlab_install_plugin_xml(${CMAKE_CURRENT_SOURCE_DIR}/${XML} XML_OUT)
list(APPEND SOURCES ${XML_OUT})

add_library(filter_measure MODULE ${SOURCES} ${HEADERS})

target_include_directories(filter_measure PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(filter_measure PUBLIC common)

set_property(TARGET filter_measure PROPERTY FOLDER Plugins)

set_property(TARGET filter_measure PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                            ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET filter_measure PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                            ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(TARGETS filter_measure DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
                COMPONENT Plugins)

=== src/meshlabplugins/filter_trioptimize/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES filter_trioptimize.cpp)

set(HEADERS curvdata.h curvedgeflip.h filter_trioptimize.h)

add_library(filter_trioptimize MODULE ${SOURCES} ${HEADERS})

target_include_directories(filter_trioptimize
                           PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(filter_trioptimize PUBLIC common)

set_property(TARGET filter_trioptimize PROPERTY FOLDER Plugins)

set_property(TARGET filter_trioptimize PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                                ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET filter_trioptimize PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                                ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(TARGETS filter_trioptimize DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
                COMPONENT Plugins)

=== src/meshlabplugins/io_base/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES baseio.cpp ${VCGDIR}/wrap/openfbx/src/miniz.c
            ${VCGDIR}/wrap/openfbx/src/ofbx.cpp ${VCGDIR}/wrap/ply/plylib.cpp)

set(HEADERS
    baseio.h
    ${VCGDIR}/wrap/io_trimesh/export_obj.h
    ${VCGDIR}/wrap/io_trimesh/export_off.h
    ${VCGDIR}/wrap/io_trimesh/export_ply.h
    ${VCGDIR}/wrap/io_trimesh/import_fbx.h
    ${VCGDIR}/wrap/io_trimesh/import_obj.h
    ${VCGDIR}/wrap/io_trimesh/import_off.h
    ${VCGDIR}/wrap/io_trimesh/import_ply.h
    ${VCGDIR}/wrap/io_trimesh/import_ptx.h
    ${VCGDIR}/wrap/io_trimesh/import_stl.h
    ${VCGDIR}/wrap/io_trimesh/io_material.h
    ${VCGDIR}/wrap/ply/plylib.h)

add_library(io_base MODULE ${SOURCES} ${HEADERS})

target_include_directories(io_base PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(io_base PUBLIC common)

target_link_libraries(io_base PRIVATE OpenGL::GLU)

set_property(TARGET io_base PROPERTY FOLDER Plugins)

set_property(TARGET io_base PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                     ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET io_base PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                     ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(TARGETS io_base DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR} COMPONENT
                Plugins)

=== src/meshlabplugins/io_json/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES io_json.cpp)

set(HEADERS io_json.h)

add_library(io_json MODULE ${SOURCES} ${HEADERS})

target_include_directories(io_json PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(io_json PUBLIC common)

set_property(TARGET io_json PROPERTY FOLDER Plugins)

set_property(TARGET io_json PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                     ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET io_json PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                     ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(TARGETS io_json DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR} COMPONENT
                Plugins)

=== src/sampleplugins/filter_geodesic/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES filter_geodesic.cpp)

set(HEADERS filter_geodesic.h)

add_library(filter_geodesic MODULE ${SOURCES} ${HEADERS})

target_include_directories(filter_geodesic PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(filter_geodesic PUBLIC common)

set_property(TARGET filter_geodesic PROPERTY FOLDER Plugins)

set_property(TARGET filter_geodesic PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                             ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET filter_geodesic PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                             ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(TARGETS filter_geodesic DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
                COMPONENT Plugins)

=== src/sampleplugins/sampleedit/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES edit_sample_factory.cpp sampleedit.cpp)

set(HEADERS edit_sample_factory.h sampleedit.h)

set(RESOURCES sampleedit.qrc)

add_library(sampleedit MODULE ${SOURCES} ${HEADERS} ${RESOURCES})

target_include_directories(sampleedit PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(sampleedit PUBLIC common)

target_link_libraries(sampleedit PRIVATE OpenGL::GLU)

set_property(TARGET sampleedit PROPERTY FOLDER Plugins)

set_property(TARGET sampleedit PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                        ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET sampleedit PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                        ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(TARGETS sampleedit DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR} COMPONENT
                Plugins)

## meshlab 2020.03+dfsg1

=== src/common/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES
    GLLogStream.cpp
    filterparameter.cpp
    filterscript.cpp
    interfaces.cpp
    meshlabdocumentbundler.cpp
    meshlabdocumentxml.cpp
    meshmodel.cpp
    ml_selection_buffers.cpp
    ml_shared_data_context.cpp
    ml_thread_safe_memory_info.cpp
    mlapplication.cpp
    pluginmanager.cpp
    scriptinterface.cpp
    scriptsyntax.cpp
    searcher.cpp
    xmlfilterinfo.cpp)

set(HEADERS
    GLLogStream.h
    filterparameter.h
    filterscript.h
    interfaces.h
    meshlabdocumentbundler.h
    meshlabdocumentxml.h
    meshmodel.h
    ml_mesh_type.h
    ml_selection_buffers.h
    ml_shared_data_context.h
    ml_thread_safe_memory_info.h
    mlapplication.h
    mlexception.h
    pluginmanager.h
    scriptinterface.h
    scriptsyntax.h
    searcher.h
    xmlfilterinfo.h)

set(RESOURCES common.qrc)

set(TARGET_TYPE SHARED)
if(WIN32)
    set(TARGET_TYPE STATIC)
endif()
add_library(common ${TARGET_TYPE} ${SOURCES} ${HEADERS} ${RESOURCES})

set_target_properties(common PROPERTIES OUTPUT_NAME meshlab-common)
target_link_libraries(
    common
    PUBLIC Qt5::Core
           Qt5::OpenGL
           Qt5::Script
           Qt5::Widgets
           Qt5::Xml
           Qt5::XmlPatterns
           external-glew
    PRIVATE external-jhead)

set_property(TARGET common PROPERTY FOLDER Core)

if(NOT WIN32)
    install(TARGETS common DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

=== src/meshlab/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES
    additionalgui.cpp
    changetexturename.cpp
    customDialog.cpp
    filterScriptDialog.cpp
    filterthread.cpp
    glarea.cpp
    glarea_setting.cpp
    layerDialog.cpp
    main.cpp
    mainwindow_Init.cpp
    mainwindow_RunTime.cpp
    ml_default_decorators.cpp
    ml_render_gui.cpp
    ml_rendering_actions.cpp
    ml_std_par_dialog.cpp
    multiViewer_Container.cpp
    plugindialog.cpp
    saveSnapshotDialog.cpp
    savemaskexporter.cpp
    stdpardialog.cpp
    xmlgeneratorgui.cpp
    xmlstdpardialog.cpp
    ${VCGDIR}/wrap/gui/trackball.cpp
    ${VCGDIR}/wrap/gui/trackmode.cpp
    ${VCGDIR}/wrap/gui/coordinateframe.cpp)

set(HEADERS
    additionalgui.h
    alnParser.h
    changetexturename.h
    customDialog.h
    filterScriptDialog.h
    filterthread.h
    glarea.h
    glarea_setting.h
    layerDialog.h
    mainwindow.h
    meshlabeditdockwidget.h
    ml_default_decorators.h
    ml_render_gui.h
    ml_rendering_actions.h
    ml_std_par_dialog.h
    multiViewer_Container.h
    plugindialog.h
    saveSnapshotDialog.h
    savemaskexporter.h
    snapshotsetting.h
    stdpardialog.h
    xmlgeneratorgui.h
    xmlstdpardialog.h
    ${VCGDIR}/wrap/gui/trackball.h
    ${VCGDIR}/wrap/gui/trackmode.h
    ${VCGDIR}/wrap/gl/trimesh.h)

set(RESOURCES meshlab.qrc)

set(UI
    ui/aboutDialog.ui
    ui/congratsDialog.ui
    ui/customDialog.ui
    ui/filterScriptDialog.ui
    ui/filtercreatortab.ui
    ui/filtergui.ui
    ui/layerDialog.ui
    ui/renametexture.ui
    ui/savemaskexporter.ui
    ui/savesnapshotDialog.ui)

set(CMAKE_AUTOUIC_SEARCH_PATHS ${CMAKE_CURRENT_SOURCE_DIR}/ui)
#if(APPLE)
#    list(APPEND SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/../install/macx/info.plist
#                images/meshlab.icns)
#endif()

if(WIN32)
    list(APPEND SOURCES meshlab.rc)
endif()

add_executable(meshlab WIN32 MACOSX_BUNDLE ${SOURCES} ${HEADERS} ${RESOURCES}
                                           ${UI})

target_compile_definitions(meshlab PUBLIC QT_DISABLE_DEPRECATED_BEFORE=0x000000)
target_include_directories(meshlab PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(
    meshlab
    PUBLIC common OpenGL::GLU Qt5::Network
    PRIVATE external-jhead)

set_property(TARGET meshlab PROPERTY FOLDER Core)

install(TARGETS meshlab DESTINATION ${MESHLAB_BIN_INSTALL_DIR} COMPONENT
                MeshLab)

if(Qt5_windeployqt_EXECUTABLE AND BUILD_WITH_WINDEPLOYQT_POST_BUILD)
    add_custom_command(
        TARGET meshlab POST_BUILD
        COMMAND "${Qt5_windeployqt_EXECUTABLE}" --no-translations
                $<TARGET_FILE_NAME:meshlab>
        WORKING_DIRECTORY $<TARGET_FILE_DIR:meshlab>
        COMMENT "Deploying Qt to the build directory of meshlab"
        VERBATIM USES_TERMINAL)
endif()

=== src/meshlabserver/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES mainserver.cpp)

set(RESOURCES meshlabserver.qrc)

list(APPEND RESOURCES ${CMAKE_CURRENT_SOURCE_DIR}/../meshlab/meshlab.qrc)
if(WIN32)
    list(APPEND SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/../meshlab/meshlab.rc)
endif()

add_executable(meshlabserver ${SOURCES} ${HEADERS} ${RESOURCES} ${UI})

target_compile_definitions(
    meshlabserver PUBLIC QT_DISABLE_DEPRECATED_BEFORE=0x000000
    NO_XSERVER_DEPENDENCY)
target_include_directories(meshlabserver PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(meshlabserver PUBLIC common Qt5::Network)

set_property(TARGET meshlabserver PROPERTY FOLDER Core)

install(TARGETS meshlabserver DESTINATION ${MESHLAB_BIN_INSTALL_DIR} COMPONENT
                MeshLab-Server)

=== src/external/levmar-2.3/CMakeLists.txt ===
# levmar CMake file; see http://www.cmake.org and 
#                        http://www.insightsoftwareconsortium.org/wiki/index.php/CMake_Tutorial

PROJECT(LEVMAR)
#CMAKE_MINIMUM_REQUIRED(VERSION 1.4)

# compiler flags
ADD_DEFINITIONS(-DLINSOLVERS_RETAIN_MEMORY) # do not free memory between linear solvers calls
#REMOVE_DEFINITIONS(-DLINSOLVERS_RETAIN_MEMORY)

# f2c is sometimes equivalent to libF77 & libI77; in that case, set HAVE_F2C to 0
SET(HAVE_F2C 1 CACHE BOOL "Do we have f2c or F77/I77?" )

# the directory where the lapack/blas/f2c libraries reside
SET(LAPACKBLAS_DIR /usr/lib CACHE PATH "Path to lapack/blas libraries")

# actual names for the lapack/blas/f2c libraries
SET(LAPACK_LIB lapack CACHE STRING "The name of the lapack library")
SET(BLAS_LIB blas CACHE STRING "The name of the blas library")
IF(HAVE_F2C)
  SET(F2C_LIB f2c CACHE STRING "The name of the f2c library")
ELSE(HAVE_F2C)
  SET(F77_LIB libF77 CACHE STRING "The name of the F77 library")
  SET(I77_LIB libI77 CACHE STRING "The name of the I77 library")
ENDIF(HAVE_F2C)

########################## NO CHANGES BEYOND THIS POINT ##########################

#INCLUDE_DIRECTORIES(/usr/include)
LINK_DIRECTORIES(${LAPACKBLAS_DIR})

# levmar library source files
ADD_LIBRARY(levmar STATIC
  lm.c Axb.c misc.c lmlec.c lmbc.c lmblec.c
  lm.h misc.h compiler.h
)

# demo program
ADD_EXECUTABLE(lmdemo lmdemo.c lm.h)
# libraries the demo depends on
IF(HAVE_F2C)
  TARGET_LINK_LIBRARIES(lmdemo levmar ${LAPACK_LIB} ${BLAS_LIB} ${F2C_LIB})
ELSE(HAVE_F2C)
  TARGET_LINK_LIBRARIES(lmdemo levmar ${LAPACK_LIB} ${BLAS_LIB} ${F77_LIB} ${I77_LIB})
ENDIF(HAVE_F2C)

# make sure that the library is built before the demo
ADD_DEPENDENCIES(lmdemo levmar)

#SUBDIRS(matlab)

#ADD_TEST(levmar_tst lmdemo)

=== src/meshlabplugins/decorate_background/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES cubemap.cpp decorate_background.cpp)

set(HEADERS cubemap.h decorate_background.h)

set(RESOURCES decorate_background.qrc)

add_library(decorate_background MODULE ${SOURCES} ${HEADERS} ${RESOURCES})

target_include_directories(decorate_background
                           PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(decorate_background PUBLIC common)

set_property(TARGET decorate_background PROPERTY FOLDER Plugins)

set_property(TARGET decorate_background PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                                 ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET decorate_background PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                                 ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(TARGETS decorate_background DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
                COMPONENT Plugins)

=== src/meshlabplugins/decorate_base/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES decorate_base.cpp ${VCGDIR}/wrap/gui/coordinateframe.cpp)

set(HEADERS colorhistogram.h decorate_base.h)

set(RESOURCES decorate_base.qrc)

add_library(decorate_base MODULE ${SOURCES} ${HEADERS} ${RESOURCES})

target_include_directories(decorate_base PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(decorate_base PUBLIC common)

target_link_libraries(decorate_base PRIVATE OpenGL::GLU)

set_property(TARGET decorate_base PROPERTY FOLDER Plugins)

set_property(TARGET decorate_base PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                           ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET decorate_base PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                           ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(TARGETS decorate_base DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
                COMPONENT Plugins)

=== src/meshlabplugins/decorate_raster_proj/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES decorate_raster_proj.cpp ${VCGDIR}/wrap/gui/trackball.cpp
            ${VCGDIR}/wrap/gui/trackmode.cpp)

set(HEADERS decorate_raster_proj.h ${VCGDIR}/wrap/gui/trackball.h)

add_library(decorate_raster_proj MODULE ${SOURCES} ${HEADERS})

target_include_directories(decorate_raster_proj
                           PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(decorate_raster_proj PUBLIC common)

set_property(TARGET decorate_raster_proj PROPERTY FOLDER Plugins)

set_property(TARGET decorate_raster_proj PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                                  ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET decorate_raster_proj PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                                  ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(TARGETS decorate_raster_proj DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
                COMPONENT Plugins)

=== src/meshlabplugins/edit_align/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

# Only build if we have newuoa
if(TARGET external-newuoa)

    set(SOURCES
        align/align_parameter.cpp
        align/AlignGlobal.cpp
        align/AlignPair.cpp
        align/OccupancyGrid.cpp
        alignDialog.cpp
        AlignPairDialog.cpp
        AlignPairWidget.cpp
        edit_align_factory.cpp
        edit_align.cpp
        meshtree.cpp
        point_matching_scale.cpp
        ../../meshlab/stdpardialog.cpp
        ${VCGDIR}/wrap/gui/trackball.cpp
        ${VCGDIR}/wrap/gui/trackmode.cpp
        ${VCGDIR}/wrap/ply/plylib.cpp)

    set(HEADERS
        align/align_parameter.h
        align/AlignGlobal.h
        align/AlignPair.h
        align/OccupancyGrid.h
        alignDialog.h
        AlignPairDialog.h
        AlignPairWidget.h
        edit_align_factory.h
        edit_align.h
        meshtree.h
        ../../meshlab/stdpardialog.h
        ${VCGDIR}/wrap/gui/trackball.h
        ${VCGDIR}/wrap/gui/trackmode.h
        ${VCGDIR}/wrap/gl/trimesh.h)

    set(RESOURCES edit_align.qrc)

    set(UI alignDialog.ui)

    add_library(edit_align MODULE ${SOURCES} ${HEADERS} ${RESOURCES} ${UI})

    target_include_directories(edit_align PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
    target_link_libraries(edit_align PUBLIC common)

    target_link_libraries(edit_align PRIVATE external-newuoa OpenGL::GLU)
    if(OpenMP_CXX_FOUND)
        target_link_libraries(edit_align PRIVATE OpenMP::OpenMP_CXX)
    endif()

    set_property(TARGET edit_align PROPERTY FOLDER Plugins)

    set_property(TARGET edit_align PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                            ${MESHLAB_PLUGIN_OUTPUT_DIR})

    set_property(TARGET edit_align PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                            ${MESHLAB_PLUGIN_OUTPUT_DIR})

    install(TARGETS edit_align DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
                    COMPONENT Plugins)

else()
    message(
        STATUS "Skipping edit_align - missing newuoa in external directory.")
endif()

=== src/meshlabplugins/edit_hole/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES edit_hole.cpp edit_hole_factory.cpp fillerDialog.cpp
            holeListModel.cpp)

set(HEADERS
    edit_hole.h
    edit_hole_factory.h
    fgtBridge.h
    fgtHole.h
    fillerDialog.h
    holeListModel.h
    holeSetManager.h)

set(RESOURCES edit_hole.qrc)

set(UI edit_hole.ui)

add_library(edit_hole MODULE ${SOURCES} ${HEADERS} ${RESOURCES} ${UI})

target_include_directories(edit_hole PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(edit_hole PUBLIC common)

set_property(TARGET edit_hole PROPERTY FOLDER Plugins)

set_property(TARGET edit_hole PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                       ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET edit_hole PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                       ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(TARGETS edit_hole DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR} COMPONENT
                Plugins)

=== src/meshlabplugins/edit_manipulators/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES edit_manipulators.cpp edit_manipulators_factory.cpp)

set(HEADERS edit_manipulators.h edit_manipulators_factory.h)

set(RESOURCES edit_manipulators.qrc)

add_library(edit_manipulators MODULE ${SOURCES} ${HEADERS} ${RESOURCES})

target_include_directories(edit_manipulators
                           PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(edit_manipulators PUBLIC common)

target_link_libraries(edit_manipulators PRIVATE OpenGL::GLU)

set_property(TARGET edit_manipulators PROPERTY FOLDER Plugins)

set_property(TARGET edit_manipulators PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                               ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET edit_manipulators PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                               ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(TARGETS edit_manipulators DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
                COMPONENT Plugins)

=== src/meshlabplugins/edit_measure/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES edit_measure.cpp edit_measure_factory.cpp
            ${VCGDIR}/wrap/gui/rubberband.cpp)

set(HEADERS edit_measure.h edit_measure_factory.h)

set(RESOURCES edit_measure.qrc)

add_library(edit_measure MODULE ${SOURCES} ${HEADERS} ${RESOURCES})

target_include_directories(edit_measure PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(edit_measure PUBLIC common)

target_link_libraries(edit_measure PRIVATE OpenGL::GLU)

set_property(TARGET edit_measure PROPERTY FOLDER Plugins)

set_property(TARGET edit_measure PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                          ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET edit_measure PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                          ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(TARGETS edit_measure DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
                COMPONENT Plugins)

=== src/meshlabplugins/edit_pickpoints/CMakeLists.txt ===
# Copyright 2019 Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

### Generated file! Edit the templates in src/templates then re-run ./make-cmake.py

set(SOURCES edit_pickpoints_factory.cpp editpickpoints.cpp
            pickPointsTemplate.cpp pickedPoints.cpp pickpointsDialog.cpp)

set(HEADERS edit_pickpoints_factory.h editpickpoints.h pickPointsTemplate.h
            pickedPoints.h pickpointsDialog.h)

set(RESOURCES editpickpoints.qrc)

set(UI pickpointsDialog.ui)

add_library(edit_pickpoints MODULE ${SOURCES} ${HEADERS} ${RESOURCES} ${UI})

target_include_directories(edit_pickpoints PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(edit_pickpoints PUBLIC common)

set_property(TARGET edit_pickpoints PROPERTY FOLDER Plugins)

set_property(TARGET edit_pickpoints PROPERTY RUNTIME_OUTPUT_DIRECTORY
                                             ${MESHLAB_PLUGIN_OUTPUT_DIR})

set_property(TARGET edit_pickpoints PROPERTY LIBRARY_OUTPUT_DIRECTORY
                                             ${MESHLAB_PLUGIN_OUTPUT_DIR})

install(TARGETS edit_pickpoints DESTINATION ${MESHLAB_PLUGIN_INSTALL_DIR}
                COMPONENT Plugins)

=== debian/changelog ===
meshlab (2020.03+dfsg1-1) unstable; urgency=medium

  [ Ryan Pavlik ]
  * Team upload.
  * New upstream version 2020.03+dfsg1. (Closes: #886580, #954092)
  * Exclude additional files pointed out by lintian.
  * Move exclusion documentation to README.source.
  * d/*: Don't use the compile date to compute the version.
  * d/watch: Update
  * d/patches: Add 25_fix_signed_char_table.patch to fix arm64, s390x, etc.
    builds
  * d/patches: Add 26_fix_filter-screened-poisson.patch from upstream to fix
    license status of filter_screened_poisson
  * d/patches: Add 27_Remove-more-__date__-usages.patch to remove more usages
    of __DATE__
  * d/rules:
    - Enable all hardening but one (format-security) to fix build.
    - Use /usr/share/dpkg/pkg-info.mk to get version string.
    - Force building with system libs.
    - Clean cme's compat file creation.
    - Adjust how build flags are set.
  * d/control:
    - Add Rules-Requires-Root: no
    - Change build dependency to libqt5opengl5-desktop-dev to disable
      armel/armhf build, due to GLES/OpenGL incompatibility. (Closes: #953062)
    - Remove unused Build-Depends left over from long ago.
    - add ryan@ryanpavlik.com to Uploaders
  * debian: copyright scan meta-files
  * debian/copyright:
    - force reorder by cme
    - Manual updates
    - Exclude non-DFSG-free PLY library.
    - Partial updates using cme
    - Fix paths, add exclusion list for repack, make more complete
  * d/meshlab.lintian-overrides: Update/fix
  * d/source: Add linitian-overrides
  * Add README.Debian
  * Make license names unique.
  * debian/get-orig-source.sh: Add a small script to generate orig.tar.gz
  * debian/README.source: Update to reflect usage of get-orig-source.sh
  * debian/docs: Install readme and privacy doc.
  * debian/patches: Retrieve patches from historical packages, refresh.
  * debian/patches/17_io_u3d.patch: Disable an export format broken by our
    repack.
  * debian/patches/18_structuresynth_license.patch: Add license to sources.
  * debian/patches/17_io_u3d.patch: Update description, mention bug.
    (Closes: #629171)
  * debian/patches/19_disable-filter_screened_poisson.patch: Disable plugin
    with DFSG-nonfree deps
  * debian/patches/03_disable-updates.patch: Refresh
  * debian/patches: Add 20_Add-desktop-file.patch to fix CMake install
  * debian/patches: Add 21_install-common-to-lib-subdir.patch (Closes: #951904)
  * debian/patches: Add 22_find-plugins.patch
  * debian/patches: Add 23_icon-install-path.patch
  * debian: Use CMake-provided install rather than picking from build dir,
    which resolves issues with RPATH.

  [ Gürkan Myczko ]
  * Use upstream manpages, drop debian/*.1
  * Reformat d/changelog.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Sat, 21 Mar 2020 18:35:13 +0100

=== debian/control ===
Source: meshlab
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ryan Pavlik <ryan@ryanpavlik.com>,
           Teemu Ikonen <tpikonen@gmail.com>,
           Gürkan Myczko <gurkan@phys.ethz.ch>
Section: graphics
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 12),
               lib3ds-dev,
               libbz2-dev,
               libeigen3-dev,
               libglew-dev,
               libglu1-mesa-dev,
               libgmp-dev,
               libmuparser-dev,
               libopenctm-dev,
               libqhull-dev,
               libqt5opengl5-desktop-dev,
               libqt5xmlpatterns5-dev,
               mesa-common-dev,
               qtbase5-dev,
               qtscript5-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/science-team/meshlab
Vcs-Git: https://salsa.debian.org/science-team/meshlab.git
Homepage: http://www.meshlab.net/
Rules-Requires-Root: no

Package: meshlab
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: chemical-mime-data
Description: System for processing and editing triangular meshes
 This is an open source, portable, and extendible system for the
 processing and editing of unstructured 3D triangular meshes.
 The system is aimed to help the processing of the typical not-so-small
 unstructured models arising in 3D scanning, providing a set of tools for
 editing, cleaning, healing, inspecting, rendering and converting this kind
 of meshes.
 .
 Meshlab can read files in these formats: PLY, STL, OFF, OBJ, 3DS, COLLADA
 and PTX. It can write PLY, STL, OFF, OBJ, 3DS, COLLADA, VRML, and DXF.

=== debian/watch ===
version=4

# Warning: This does not apparently get the submodules: still need to use get-orig-source.sh

opts=dversionmangle=s/[+.]dfsg\d+//,filenamemangle=s:.*/[Mm]esh[Ll]ab:meshlab: \
    https://github.com/cnr-isti-vclab/meshlab/tags .*/Mesh[Ll]ab-(\d{4}.\d{2})\.tar\.gz
